diff --git a/src/backend/utils/adt/txid.c b/src/backend/utils/adt/txid.c
new file mode 100644
index 5dd996f..73d3d20
*** a/src/backend/utils/adt/txid.c
--- b/src/backend/utils/adt/txid.c
***************
*** 38,48 ****
  /* txid will be signed int8 in database, so must limit to 63 bits */
  #define MAX_TXID   ((uint64) PG_INT64_MAX)
  
- /* Use unsigned variant internally */
- typedef uint64 txid;
- 
- /* sprintf format code for uint64 */
- #define TXID_FMT UINT64_FORMAT
  
  /*
   * If defined, use bsearch() function for searching for txids in snapshots
--- 38,43 ----
*************** typedef struct
*** 61,186 ****
  	 *
  	 * Explicit embedding is ok as we want always correct alignment anyway.
  	 */
! 	int32		__varsz;
  
! 	uint32		nxip;			/* number of txids in xip array */
! 	txid		xmin;
! 	txid		xmax;
  	/* in-progress txids, xmin <= xip[i] < xmax: */
! 	txid		xip[FLEXIBLE_ARRAY_MEMBER];
  } TxidSnapshot;
  
  #define TXID_SNAPSHOT_SIZE(nxip) \
! 	(offsetof(TxidSnapshot, xip) + sizeof(txid) * (nxip))
  #define TXID_SNAPSHOT_MAX_NXIP \
! 	((MaxAllocSize - offsetof(TxidSnapshot, xip)) / sizeof(txid))
! 
! /*
!  * Epoch values from xact.c
!  */
! typedef struct
! {
! 	TransactionId last_xid;
! 	uint32		epoch;
! } TxidEpoch;
! 
! 
! /*
!  * Fetch epoch data from xact.c.
!  */
! static void
! load_xid_epoch(TxidEpoch *state)
! {
! 	GetNextXidAndEpoch(&state->last_xid, &state->epoch);
! }
! 
! /*
!  * Helper to get a TransactionId from a 64-bit xid with wraparound detection.
!  *
!  * It is an ERROR if the xid is in the future.  Otherwise, returns true if
!  * the transaction is still new enough that we can determine whether it
!  * committed and false otherwise.  If *extracted_xid is not NULL, it is set
!  * to the low 32 bits of the transaction ID (i.e. the actual XID, without the
!  * epoch).
!  *
!  * The caller must hold CLogTruncationLock since it's dealing with arbitrary
!  * XIDs, and must continue to hold it until it's done with any clog lookups
!  * relating to those XIDs.
!  */
! static bool
! TransactionIdInRecentPast(uint64 xid_with_epoch, TransactionId *extracted_xid)
! {
! 	uint32		xid_epoch = (uint32) (xid_with_epoch >> 32);
! 	TransactionId xid = (TransactionId) xid_with_epoch;
! 	uint32		now_epoch;
! 	TransactionId now_epoch_last_xid;
! 
! 	GetNextXidAndEpoch(&now_epoch_last_xid, &now_epoch);
! 
! 	if (extracted_xid != NULL)
! 		*extracted_xid = xid;
! 
! 	if (!TransactionIdIsValid(xid))
! 		return false;
! 
! 	/* For non-normal transaction IDs, we can ignore the epoch. */
! 	if (!TransactionIdIsNormal(xid))
! 		return true;
! 
! 	/* If the transaction ID is in the future, throw an error. */
! 	if (xid_epoch > now_epoch
! 		|| (xid_epoch == now_epoch && xid > now_epoch_last_xid))
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
! 				 errmsg("transaction ID " UINT64_FORMAT " is in the future",
! 						xid_with_epoch)));
! 
! 	/*
! 	 * ShmemVariableCache->oldestClogXid is protected by CLogTruncationLock,
! 	 * but we don't acquire that lock here.  Instead, we require the caller to
! 	 * acquire it, because the caller is presumably going to look up the
! 	 * returned XID.  If we took and released the lock within this function, a
! 	 * CLOG truncation could occur before the caller finished with the XID.
! 	 */
! 	Assert(LWLockHeldByMe(CLogTruncationLock));
! 
! 	/*
! 	 * If the transaction ID has wrapped around, it's definitely too old to
! 	 * determine the commit status.  Otherwise, we can compare it to
! 	 * ShmemVariableCache->oldestClogXid to determine whether the relevant
! 	 * CLOG entry is guaranteed to still exist.
! 	 */
! 	if (xid_epoch + 1 < now_epoch
! 		|| (xid_epoch + 1 == now_epoch && xid < now_epoch_last_xid)
! 		|| TransactionIdPrecedes(xid, ShmemVariableCache->oldestClogXid))
! 		return false;
! 
! 	return true;
! }
! 
! /*
!  * do a TransactionId -> txid conversion for an XID near the given epoch
!  */
! static txid
! convert_xid(TransactionId xid, const TxidEpoch *state)
! {
! 	uint64		epoch;
! 
! 	/* return special xid's as-is */
! 	if (!TransactionIdIsNormal(xid))
! 		return (txid) xid;
! 
! 	/* xid can be on either side when near wrap-around */
! 	epoch = (uint64) state->epoch;
! 	if (xid > state->last_xid &&
! 		TransactionIdPrecedes(xid, state->last_xid))
! 		epoch--;
! 	else if (xid < state->last_xid &&
! 			 TransactionIdFollows(xid, state->last_xid))
! 		epoch++;
! 
! 	return (epoch << 32) | xid;
! }
  
  /*
   * txid comparator for qsort/bsearch
--- 56,74 ----
  	 *
  	 * Explicit embedding is ok as we want always correct alignment anyway.
  	 */
! 	int32			__varsz;
  
! 	uint32			nxip;			/* number of txids in xip array */
! 	TransactionId	xmin;
! 	TransactionId	xmax;
  	/* in-progress txids, xmin <= xip[i] < xmax: */
! 	TransactionId	xip[FLEXIBLE_ARRAY_MEMBER];
  } TxidSnapshot;
  
  #define TXID_SNAPSHOT_SIZE(nxip) \
! 	(offsetof(TxidSnapshot, xip) + sizeof(TransactionId) * (nxip))
  #define TXID_SNAPSHOT_MAX_NXIP \
! 	((MaxAllocSize - offsetof(TxidSnapshot, xip)) / sizeof(TransactionId))
  
  /*
   * txid comparator for qsort/bsearch
*************** convert_xid(TransactionId xid, const Txi
*** 188,195 ****
  static int
  cmp_txid(const void *aa, const void *bb)
  {
! 	txid		a = *(const txid *) aa;
! 	txid		b = *(const txid *) bb;
  
  	if (a < b)
  		return -1;
--- 76,83 ----
  static int
  cmp_txid(const void *aa, const void *bb)
  {
! 	TransactionId	a = *(const TransactionId *) aa;
! 	TransactionId	b = *(const TransactionId *) bb;
  
  	if (a < b)
  		return -1;
*************** cmp_txid(const void *aa, const void *bb)
*** 208,221 ****
  static void
  sort_snapshot(TxidSnapshot *snap)
  {
! 	txid		last = 0;
! 	int			nxip,
! 				idx1,
! 				idx2;
  
  	if (snap->nxip > 1)
  	{
! 		qsort(snap->xip, snap->nxip, sizeof(txid), cmp_txid);
  
  		/* remove duplicates */
  		nxip = snap->nxip;
--- 96,109 ----
  static void
  sort_snapshot(TxidSnapshot *snap)
  {
! 	TransactionId	last = 0;
! 	int				nxip,
! 					idx1,
! 					idx2;
  
  	if (snap->nxip > 1)
  	{
! 		qsort(snap->xip, snap->nxip, sizeof(TransactionId), cmp_txid);
  
  		/* remove duplicates */
  		nxip = snap->nxip;
*************** sort_snapshot(TxidSnapshot *snap)
*** 235,241 ****
   * check txid visibility.
   */
  static bool
! is_visible_txid(txid value, const TxidSnapshot *snap)
  {
  	if (value < snap->xmin)
  		return true;
--- 123,129 ----
   * check txid visibility.
   */
  static bool
! is_visible_txid(TransactionId value, const TxidSnapshot *snap)
  {
  	if (value < snap->xmin)
  		return true;
*************** is_visible_txid(txid value, const TxidSn
*** 246,252 ****
  	{
  		void	   *res;
  
! 		res = bsearch(&value, snap->xip, snap->nxip, sizeof(txid), cmp_txid);
  		/* if found, transaction is still in progress */
  		return (res) ? false : true;
  	}
--- 134,140 ----
  	{
  		void	   *res;
  
! 		res = bsearch(&value, snap->xip, snap->nxip, sizeof(TransactionId), cmp_txid);
  		/* if found, transaction is still in progress */
  		return (res) ? false : true;
  	}
*************** is_visible_txid(txid value, const TxidSn
*** 269,275 ****
   */
  
  static StringInfo
! buf_init(txid xmin, txid xmax)
  {
  	TxidSnapshot snap;
  	StringInfo	buf;
--- 157,163 ----
   */
  
  static StringInfo
! buf_init(TransactionId xmin, TransactionId xmax)
  {
  	TxidSnapshot snap;
  	StringInfo	buf;
*************** buf_init(txid xmin, txid xmax)
*** 284,290 ****
  }
  
  static void
! buf_add_txid(StringInfo buf, txid xid)
  {
  	TxidSnapshot *snap = (TxidSnapshot *) buf->data;
  
--- 172,178 ----
  }
  
  static void
! buf_add_txid(StringInfo buf, TransactionId xid)
  {
  	TxidSnapshot *snap = (TxidSnapshot *) buf->data;
  
*************** buf_finalize(StringInfo buf)
*** 311,324 ****
  /*
   * simple number parser.
   *
!  * We return 0 on error, which is invalid value for txid.
   */
! static txid
  str2txid(const char *s, const char **endp)
  {
! 	txid		val = 0;
! 	txid		cutoff = MAX_TXID / 10;
! 	txid		cutlim = MAX_TXID % 10;
  
  	for (; *s; s++)
  	{
--- 199,212 ----
  /*
   * simple number parser.
   *
!  * We return 0 on error, which is invalid value for TransactionId.
   */
! static TransactionId
  str2txid(const char *s, const char **endp)
  {
! 	TransactionId		val = 0;
! 	TransactionId		cutoff = MAX_TXID / 10;
! 	TransactionId		cutlim = MAX_TXID % 10;
  
  	for (; *s; s++)
  	{
*************** str2txid(const char *s, const char **end
*** 350,362 ****
  static TxidSnapshot *
  parse_snapshot(const char *str)
  {
! 	txid		xmin;
! 	txid		xmax;
! 	txid		last_val = 0,
! 				val;
! 	const char *str_start = str;
! 	const char *endp;
! 	StringInfo	buf;
  
  	xmin = str2txid(str, &endp);
  	if (*endp != ':')
--- 238,250 ----
  static TxidSnapshot *
  parse_snapshot(const char *str)
  {
! 	TransactionId	xmin;
! 	TransactionId	xmax;
! 	TransactionId	last_val = 0,
! 					val;
! 	const char	   *str_start = str;
! 	const char	   *endp;
! 	StringInfo		buf;
  
  	xmin = str2txid(str, &endp);
  	if (*endp != ':')
*************** bad_format:
*** 418,448 ****
  /*
   * txid_current() returns int8
   *
!  *	Return the current toplevel transaction ID as TXID
!  *	If the current transaction does not have one, one is assigned.
!  *
!  *	This value has the epoch as the high 32 bits and the 32-bit xid
!  *	as the low 32 bits.
   */
  Datum
  txid_current(PG_FUNCTION_ARGS)
  {
! 	txid		val;
! 	TxidEpoch	state;
! 
! 	/*
! 	 * Must prevent during recovery because if an xid is not assigned we try
! 	 * to assign one, which would fail. Programs already rely on this function
! 	 * to always return a valid current xid, so we should not change this to
! 	 * return NULL or similar invalid xid.
! 	 */
! 	PreventCommandDuringRecovery("txid_current()");
! 
! 	load_xid_epoch(&state);
! 
! 	val = convert_xid(GetTopTransactionId(), &state);
! 
! 	PG_RETURN_INT64(val);
  }
  
  /*
--- 306,317 ----
  /*
   * txid_current() returns int8
   *
!  *	Return the current toplevel transaction ID
   */
  Datum
  txid_current(PG_FUNCTION_ARGS)
  {
! 	PG_RETURN_INT64(GetTopTransactionId());
  }
  
  /*
*************** txid_current(PG_FUNCTION_ARGS)
*** 452,469 ****
  Datum
  txid_current_if_assigned(PG_FUNCTION_ARGS)
  {
! 	txid		val;
! 	TxidEpoch	state;
! 	TransactionId topxid = GetTopTransactionIdIfAny();
  
! 	if (topxid == InvalidTransactionId)
  		PG_RETURN_NULL();
- 
- 	load_xid_epoch(&state);
- 
- 	val = convert_xid(topxid, &state);
- 
- 	PG_RETURN_INT64(val);
  }
  
  /*
--- 321,332 ----
  Datum
  txid_current_if_assigned(PG_FUNCTION_ARGS)
  {
! 	TransactionId xid = GetTopTransactionIdIfAny();
  
! 	if (TransactionIdIsValid(xid))
! 		PG_RETURN_INT64(xid);
! 	else
  		PG_RETURN_NULL();
  }
  
  /*
*************** txid_current_snapshot(PG_FUNCTION_ARGS)
*** 479,493 ****
  	TxidSnapshot *snap;
  	uint32		nxip,
  				i;
- 	TxidEpoch	state;
  	Snapshot	cur;
  
  	cur = GetActiveSnapshot();
  	if (cur == NULL)
  		elog(ERROR, "no active snapshot set");
  
- 	load_xid_epoch(&state);
- 
  	/*
  	 * Compile-time limits on the procarray (MAX_BACKENDS processes plus
  	 * MAX_BACKENDS prepared transactions) guarantee nxip won't be too large.
--- 342,353 ----
*************** txid_current_snapshot(PG_FUNCTION_ARGS)
*** 500,510 ****
  	snap = palloc(TXID_SNAPSHOT_SIZE(nxip));
  
  	/* fill */
! 	snap->xmin = convert_xid(cur->xmin, &state);
! 	snap->xmax = convert_xid(cur->xmax, &state);
  	snap->nxip = nxip;
  	for (i = 0; i < nxip; i++)
! 		snap->xip[i] = convert_xid(cur->xip[i], &state);
  
  	/*
  	 * We want them guaranteed to be in ascending order.  This also removes
--- 360,370 ----
  	snap = palloc(TXID_SNAPSHOT_SIZE(nxip));
  
  	/* fill */
! 	snap->xmin = cur->xmin;
! 	snap->xmax = cur->xmax;
  	snap->nxip = nxip;
  	for (i = 0; i < nxip; i++)
! 		snap->xip[i] = cur->xip[i];
  
  	/*
  	 * We want them guaranteed to be in ascending order.  This also removes
*************** txid_snapshot_out(PG_FUNCTION_ARGS)
*** 551,564 ****
  
  	initStringInfo(&str);
  
! 	appendStringInfo(&str, TXID_FMT ":", snap->xmin);
! 	appendStringInfo(&str, TXID_FMT ":", snap->xmax);
  
  	for (i = 0; i < snap->nxip; i++)
  	{
  		if (i > 0)
  			appendStringInfoChar(&str, ',');
! 		appendStringInfo(&str, TXID_FMT, snap->xip[i]);
  	}
  
  	PG_RETURN_CSTRING(str.data);
--- 411,424 ----
  
  	initStringInfo(&str);
  
! 	appendStringInfo(&str, XID_FMT ":", snap->xmin);
! 	appendStringInfo(&str, XID_FMT ":", snap->xmax);
  
  	for (i = 0; i < snap->nxip; i++)
  	{
  		if (i > 0)
  			appendStringInfoChar(&str, ',');
! 		appendStringInfo(&str, XID_FMT, snap->xip[i]);
  	}
  
  	PG_RETURN_CSTRING(str.data);
*************** txid_snapshot_out(PG_FUNCTION_ARGS)
*** 574,586 ****
  Datum
  txid_snapshot_recv(PG_FUNCTION_ARGS)
  {
! 	StringInfo	buf = (StringInfo) PG_GETARG_POINTER(0);
! 	TxidSnapshot *snap;
! 	txid		last = 0;
! 	int			nxip;
! 	int			i;
! 	txid		xmin,
! 				xmax;
  
  	/* load and validate nxip */
  	nxip = pq_getmsgint(buf, 4);
--- 434,446 ----
  Datum
  txid_snapshot_recv(PG_FUNCTION_ARGS)
  {
! 	StringInfo		buf = (StringInfo) PG_GETARG_POINTER(0);
! 	TxidSnapshot   *snap;
! 	TransactionId	last = 0;
! 	int				nxip;
! 	int				i;
! 	TransactionId	xmin,
! 					xmax;
  
  	/* load and validate nxip */
  	nxip = pq_getmsgint(buf, 4);
*************** txid_snapshot_recv(PG_FUNCTION_ARGS)
*** 598,604 ****
  
  	for (i = 0; i < nxip; i++)
  	{
! 		txid		cur = pq_getmsgint64(buf);
  
  		if (cur < last || cur < xmin || cur >= xmax)
  			goto bad_format;
--- 458,464 ----
  
  	for (i = 0; i < nxip; i++)
  	{
! 		TransactionId	cur = pq_getmsgint64(buf);
  
  		if (cur < last || cur < xmin || cur >= xmax)
  			goto bad_format;
*************** txid_snapshot_send(PG_FUNCTION_ARGS)
*** 656,663 ****
  Datum
  txid_visible_in_snapshot(PG_FUNCTION_ARGS)
  {
! 	txid		value = PG_GETARG_INT64(0);
! 	TxidSnapshot *snap = (TxidSnapshot *) PG_GETARG_VARLENA_P(1);
  
  	PG_RETURN_BOOL(is_visible_txid(value, snap));
  }
--- 516,523 ----
  Datum
  txid_visible_in_snapshot(PG_FUNCTION_ARGS)
  {
! 	TransactionId	value = PG_GETARG_INT64(0);
! 	TxidSnapshot   *snap = (TxidSnapshot *) PG_GETARG_VARLENA_P(1);
  
  	PG_RETURN_BOOL(is_visible_txid(value, snap));
  }
*************** Datum
*** 697,704 ****
  txid_snapshot_xip(PG_FUNCTION_ARGS)
  {
  	FuncCallContext *fctx;
! 	TxidSnapshot *snap;
! 	txid		value;
  
  	/* on first call initialize snap_state and get copy of snapshot */
  	if (SRF_IS_FIRSTCALL())
--- 557,564 ----
  txid_snapshot_xip(PG_FUNCTION_ARGS)
  {
  	FuncCallContext *fctx;
! 	TxidSnapshot   *snap;
! 	TransactionId	value;
  
  	/* on first call initialize snap_state and get copy of snapshot */
  	if (SRF_IS_FIRSTCALL())
*************** txid_snapshot_xip(PG_FUNCTION_ARGS)
*** 732,739 ****
   * Report the status of a recent transaction ID, or null for wrapped,
   * truncated away or otherwise too old XIDs.
   *
!  * The passed epoch-qualified xid is treated as a normal xid, not a
!  * multixact id.
   *
   * If it points to a committed subxact the result is the subxact status even
   * though the parent xact may still be in progress or may have aborted.
--- 592,598 ----
   * Report the status of a recent transaction ID, or null for wrapped,
   * truncated away or otherwise too old XIDs.
   *
!  * The passed xid is treated as a normal xid, not a multixact id.
   *
   * If it points to a committed subxact the result is the subxact status even
   * though the parent xact may still be in progress or may have aborted.
*************** Datum
*** 742,787 ****
  txid_status(PG_FUNCTION_ARGS)
  {
  	const char *status;
! 	uint64		xid_with_epoch = PG_GETARG_INT64(0);
! 	TransactionId xid;
  
  	/*
  	 * We must protect against concurrent truncation of clog entries to avoid
  	 * an I/O error on SLRU lookup.
  	 */
  	LWLockAcquire(CLogTruncationLock, LW_SHARED);
! 	if (TransactionIdInRecentPast(xid_with_epoch, &xid))
! 	{
! 		Assert(TransactionIdIsValid(xid));
  
! 		if (TransactionIdIsCurrentTransactionId(xid))
! 			status = gettext_noop("in progress");
! 		else if (TransactionIdDidCommit(xid))
! 			status = gettext_noop("committed");
! 		else if (TransactionIdDidAbort(xid))
! 			status = gettext_noop("aborted");
! 		else
! 		{
! 			/*
! 			 * The xact is not marked as either committed or aborted in clog.
! 			 *
! 			 * It could be a transaction that ended without updating clog or
! 			 * writing an abort record due to a crash. We can safely assume
! 			 * it's aborted if it isn't committed and is older than our
! 			 * snapshot xmin.
! 			 *
! 			 * Otherwise it must be in-progress (or have been at the time we
! 			 * checked commit/abort status).
! 			 */
! 			if (TransactionIdPrecedes(xid, GetActiveSnapshot()->xmin))
! 				status = gettext_noop("aborted");
! 			else
! 				status = gettext_noop("in progress");
! 		}
  	}
  	else
  	{
! 		status = NULL;
  	}
  	LWLockRelease(CLogTruncationLock);
  
--- 601,648 ----
  txid_status(PG_FUNCTION_ARGS)
  {
  	const char *status;
! 	TransactionId xid = PG_GETARG_TRANSACTIONID(0);
  
  	/*
  	 * We must protect against concurrent truncation of clog entries to avoid
  	 * an I/O error on SLRU lookup.
  	 */
  	LWLockAcquire(CLogTruncationLock, LW_SHARED);
! 	Assert(TransactionIdIsValid(xid));
  
! 	if (TransactionIdIsNormal(xid) &&
! 		TransactionIdPrecedes(xid, ShmemVariableCache->oldestClogXid))
! 		status = NULL;
! 	else if (TransactionIdPrecedesOrEquals(ReadNewTransactionId(), xid))
! 	{
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
! 				 errmsg("transaction ID " XID_FMT " is in the future",
! 						xid)));
  	}
+ 	else if (TransactionIdIsCurrentTransactionId(xid))
+ 		status = gettext_noop("in progress");
+ 	else if (TransactionIdDidCommit(xid))
+ 		status = gettext_noop("committed");
+ 	else if (TransactionIdDidAbort(xid))
+ 		status = gettext_noop("aborted");
  	else
  	{
! 		/*
! 		 * The xact is not marked as either committed or aborted in clog.
! 		 *
! 		 * It could be a transaction that ended without updating clog or
! 		 * writing an abort record due to a crash. We can safely assume
! 		 * it's aborted if it isn't committed and is older than our
! 		 * snapshot xmin.
! 		 *
! 		 * Otherwise it must be in-progress (or have been at the time we
! 		 * checked commit/abort status).
! 		 */
! 		if (TransactionIdPrecedes(xid, GetActiveSnapshot()->xmin))
! 			status = gettext_noop("aborted");
! 		else
! 			status = gettext_noop("in progress");
  	}
  	LWLockRelease(CLogTruncationLock);
  
diff --git a/src/backend/utils/adt/xid.c b/src/backend/utils/adt/xid.c
new file mode 100644
index 2051709..6d327fb
*** a/src/backend/utils/adt/xid.c
--- b/src/backend/utils/adt/xid.c
***************
*** 22,30 ****
  #include "libpq/pqformat.h"
  #include "utils/builtins.h"
  
- #define PG_GETARG_TRANSACTIONID(n)	DatumGetTransactionId(PG_GETARG_DATUM(n))
- #define PG_RETURN_TRANSACTIONID(x)	return TransactionIdGetDatum(x)
- 
  #define PG_GETARG_COMMANDID(n)		DatumGetCommandId(PG_GETARG_DATUM(n))
  #define PG_RETURN_COMMANDID(x)		return CommandIdGetDatum(x)
  
--- 22,27 ----
*************** xidin(PG_FUNCTION_ARGS)
*** 34,49 ****
  {
  	char	   *str = PG_GETARG_CSTRING(0);
  
! 	PG_RETURN_TRANSACTIONID((TransactionId) strtoul(str, NULL, 0));
  }
  
  Datum
  xidout(PG_FUNCTION_ARGS)
  {
  	TransactionId transactionId = PG_GETARG_TRANSACTIONID(0);
! 	char	   *result = (char *) palloc(16);
  
! 	snprintf(result, 16, "%lu", (unsigned long) transactionId);
  	PG_RETURN_CSTRING(result);
  }
  
--- 31,46 ----
  {
  	char	   *str = PG_GETARG_CSTRING(0);
  
! 	PG_RETURN_TRANSACTIONID((TransactionId) pg_strtouint64(str, NULL, 0));
  }
  
  Datum
  xidout(PG_FUNCTION_ARGS)
  {
  	TransactionId transactionId = PG_GETARG_TRANSACTIONID(0);
! 	char	   *result = (char *) palloc(32);
  
! 	snprintf(result, 32, XID_FMT, transactionId);
  	PG_RETURN_CSTRING(result);
  }
  
*************** Datum
*** 54,61 ****
  xidrecv(PG_FUNCTION_ARGS)
  {
  	StringInfo	buf = (StringInfo) PG_GETARG_POINTER(0);
  
! 	PG_RETURN_TRANSACTIONID((TransactionId) pq_getmsgint(buf, sizeof(TransactionId)));
  }
  
  /*
--- 51,62 ----
  xidrecv(PG_FUNCTION_ARGS)
  {
  	StringInfo	buf = (StringInfo) PG_GETARG_POINTER(0);
+ 	uint32	lo, hi;
  
! 	lo = (uint32) pq_getmsgint(buf, sizeof(TransactionId));
! 	hi = (uint32) pq_getmsgint(buf, sizeof(TransactionId));
! 
! 	PG_RETURN_TRANSACTIONID((uint64) lo + ((uint64) hi << 32));
  }
  
  /*
*************** xidsend(PG_FUNCTION_ARGS)
*** 66,74 ****
  {
  	TransactionId arg1 = PG_GETARG_TRANSACTIONID(0);
  	StringInfoData buf;
  
  	pq_begintypsend(&buf);
! 	pq_sendint(&buf, arg1, sizeof(arg1));
  	PG_RETURN_BYTEA_P(pq_endtypsend(&buf));
  }
  
--- 67,80 ----
  {
  	TransactionId arg1 = PG_GETARG_TRANSACTIONID(0);
  	StringInfoData buf;
+ 	uint32	lo, hi;
+ 
+ 	lo = (uint32) (arg1 & 0xFFFFFFFF);
+ 	hi = (uint32) (arg1 >> 32);
  
  	pq_begintypsend(&buf);
! 	pq_sendint(&buf, lo, sizeof(lo));
! 	pq_sendint(&buf, hi, sizeof(hi));
  	PG_RETURN_BYTEA_P(pq_endtypsend(&buf));
  }
  
diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
new file mode 100644
index c2e8361..738b6da
*** a/src/backend/utils/cache/relcache.c
--- b/src/backend/utils/cache/relcache.c
*************** RelationReloadIndexInfo(Relation relatio
*** 2284,2291 ****
  		relation->rd_index->indislive = index->indislive;
  
  		/* Copy xmin too, as that is needed to make sense of indcheckxmin */
! 		HeapTupleHeaderSetXmin(relation->rd_indextuple->t_data,
! 							   HeapTupleHeaderGetXmin(tuple->t_data));
  
  		ReleaseSysCache(tuple);
  	}
--- 2284,2292 ----
  		relation->rd_index->indislive = index->indislive;
  
  		/* Copy xmin too, as that is needed to make sense of indcheckxmin */
! 		relation->rd_indextuple->t_xid_base = tuple->t_xid_base;
! 		HeapTupleSetXmin(relation->rd_indextuple,
! 						 HeapTupleGetXmin(tuple));
  
  		ReleaseSysCache(tuple);
  	}
diff --git a/src/backend/utils/error/elog.c b/src/backend/utils/error/elog.c
new file mode 100644
index 22004cb..0cae92f
*** a/src/backend/utils/error/elog.c
--- b/src/backend/utils/error/elog.c
*************** log_line_prefix(StringInfo buf, ErrorDat
*** 2584,2595 ****
  					{
  						char		strfbuf[128];
  
! 						snprintf(strfbuf, sizeof(strfbuf) - 1, "%d/%u",
  								 MyProc->backendId, MyProc->lxid);
  						appendStringInfo(buf, "%*s", padding, strfbuf);
  					}
  					else
! 						appendStringInfo(buf, "%d/%u", MyProc->backendId, MyProc->lxid);
  				}
  				else if (padding != 0)
  					appendStringInfoSpaces(buf,
--- 2584,2595 ----
  					{
  						char		strfbuf[128];
  
! 						snprintf(strfbuf, sizeof(strfbuf) - 1, "%d/" XID_FMT,
  								 MyProc->backendId, MyProc->lxid);
  						appendStringInfo(buf, "%*s", padding, strfbuf);
  					}
  					else
! 						appendStringInfo(buf, "%d/" XID_FMT, MyProc->backendId, MyProc->lxid);
  				}
  				else if (padding != 0)
  					appendStringInfoSpaces(buf,
*************** log_line_prefix(StringInfo buf, ErrorDat
*** 2597,2605 ****
  				break;
  			case 'x':
  				if (padding != 0)
! 					appendStringInfo(buf, "%*u", padding, GetTopTransactionIdIfAny());
  				else
! 					appendStringInfo(buf, "%u", GetTopTransactionIdIfAny());
  				break;
  			case 'e':
  				if (padding != 0)
--- 2597,2605 ----
  				break;
  			case 'x':
  				if (padding != 0)
! 					appendStringInfo(buf, "%*" INT64_MODIFIER "u", padding, GetTopTransactionIdIfAny());
  				else
! 					appendStringInfo(buf, XID_FMT, GetTopTransactionIdIfAny());
  				break;
  			case 'e':
  				if (padding != 0)
*************** write_csvlog(ErrorData *edata)
*** 2746,2756 ****
  	/* Virtual transaction id */
  	/* keep VXID format in sync with lockfuncs.c */
  	if (MyProc != NULL && MyProc->backendId != InvalidBackendId)
! 		appendStringInfo(&buf, "%d/%u", MyProc->backendId, MyProc->lxid);
  	appendStringInfoChar(&buf, ',');
  
  	/* Transaction id */
! 	appendStringInfo(&buf, "%u", GetTopTransactionIdIfAny());
  	appendStringInfoChar(&buf, ',');
  
  	/* Error severity */
--- 2746,2756 ----
  	/* Virtual transaction id */
  	/* keep VXID format in sync with lockfuncs.c */
  	if (MyProc != NULL && MyProc->backendId != InvalidBackendId)
! 		appendStringInfo(&buf, "%d/" XID_FMT, MyProc->backendId, MyProc->lxid);
  	appendStringInfoChar(&buf, ',');
  
  	/* Transaction id */
! 	appendStringInfo(&buf, XID_FMT, GetTopTransactionIdIfAny());
  	appendStringInfoChar(&buf, ',');
  
  	/* Error severity */
diff --git a/src/backend/utils/fmgr/fmgr.c b/src/backend/utils/fmgr/fmgr.c
new file mode 100644
index f6d2b7d..d0f9530
*** a/src/backend/utils/fmgr/fmgr.c
--- b/src/backend/utils/fmgr/fmgr.c
*************** lookup_C_func(HeapTuple procedureTuple)
*** 455,461 ****
  					NULL);
  	if (entry == NULL)
  		return NULL;			/* no such entry */
! 	if (entry->fn_xmin == HeapTupleHeaderGetRawXmin(procedureTuple->t_data) &&
  		ItemPointerEquals(&entry->fn_tid, &procedureTuple->t_self))
  		return entry;			/* OK */
  	return NULL;				/* entry is out of date */
--- 455,461 ----
  					NULL);
  	if (entry == NULL)
  		return NULL;			/* no such entry */
! 	if (entry->fn_xmin == HeapTupleGetRawXmin(procedureTuple) &&
  		ItemPointerEquals(&entry->fn_tid, &procedureTuple->t_self))
  		return entry;			/* OK */
  	return NULL;				/* entry is out of date */
*************** record_C_func(HeapTuple procedureTuple,
*** 492,498 ****
  					HASH_ENTER,
  					&found);
  	/* OID is already filled in */
! 	entry->fn_xmin = HeapTupleHeaderGetRawXmin(procedureTuple->t_data);
  	entry->fn_tid = procedureTuple->t_self;
  	entry->user_fn = user_fn;
  	entry->inforec = inforec;
--- 492,498 ----
  					HASH_ENTER,
  					&found);
  	/* OID is already filled in */
! 	entry->fn_xmin = HeapTupleGetRawXmin(procedureTuple);
  	entry->fn_tid = procedureTuple->t_self;
  	entry->user_fn = user_fn;
  	entry->inforec = inforec;
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
new file mode 100644
index 9972deb..1747558
*** a/src/backend/utils/misc/guc.c
--- b/src/backend/utils/misc/guc.c
*************** static struct config_int ConfigureNamesI
*** 2123,2178 ****
  		NULL, NULL, NULL
  	},
  
- 	{
- 		{"vacuum_freeze_min_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
- 			gettext_noop("Minimum age at which VACUUM should freeze a table row."),
- 			NULL
- 		},
- 		&vacuum_freeze_min_age,
- 		50000000, 0, 1000000000,
- 		NULL, NULL, NULL
- 	},
- 
- 	{
- 		{"vacuum_freeze_table_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
- 			gettext_noop("Age at which VACUUM should scan whole table to freeze tuples."),
- 			NULL
- 		},
- 		&vacuum_freeze_table_age,
- 		150000000, 0, 2000000000,
- 		NULL, NULL, NULL
- 	},
- 
- 	{
- 		{"vacuum_multixact_freeze_min_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
- 			gettext_noop("Minimum age at which VACUUM should freeze a MultiXactId in a table row."),
- 			NULL
- 		},
- 		&vacuum_multixact_freeze_min_age,
- 		5000000, 0, 1000000000,
- 		NULL, NULL, NULL
- 	},
- 
- 	{
- 		{"vacuum_multixact_freeze_table_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
- 			gettext_noop("Multixact age at which VACUUM should scan whole table to freeze tuples."),
- 			NULL
- 		},
- 		&vacuum_multixact_freeze_table_age,
- 		150000000, 0, 2000000000,
- 		NULL, NULL, NULL
- 	},
- 
- 	{
- 		{"vacuum_defer_cleanup_age", PGC_SIGHUP, REPLICATION_MASTER,
- 			gettext_noop("Number of transactions by which VACUUM and HOT cleanup should be deferred, if any."),
- 			NULL
- 		},
- 		&vacuum_defer_cleanup_age,
- 		0, 0, 1000000,
- 		NULL, NULL, NULL
- 	},
- 
  	/*
  	 * See also CheckRequiredParameterValues() if this parameter changes
  	 */
--- 2123,2128 ----
*************** static struct config_int ConfigureNamesI
*** 2675,2701 ****
  		NULL, NULL, NULL
  	},
  	{
- 		/* see varsup.c for why this is PGC_POSTMASTER not PGC_SIGHUP */
- 		{"autovacuum_freeze_max_age", PGC_POSTMASTER, AUTOVACUUM,
- 			gettext_noop("Age at which to autovacuum a table to prevent transaction ID wraparound."),
- 			NULL
- 		},
- 		&autovacuum_freeze_max_age,
- 		/* see pg_resetwal if you change the upper-limit value */
- 		200000000, 100000, 2000000000,
- 		NULL, NULL, NULL
- 	},
- 	{
- 		/* see multixact.c for why this is PGC_POSTMASTER not PGC_SIGHUP */
- 		{"autovacuum_multixact_freeze_max_age", PGC_POSTMASTER, AUTOVACUUM,
- 			gettext_noop("Multixact age at which to autovacuum a table to prevent multixact wraparound."),
- 			NULL
- 		},
- 		&autovacuum_multixact_freeze_max_age,
- 		400000000, 10000, 2000000000,
- 		NULL, NULL, NULL
- 	},
- 	{
  		/* see max_connections */
  		{"autovacuum_max_workers", PGC_POSTMASTER, AUTOVACUUM,
  			gettext_noop("Sets the maximum number of simultaneously running autovacuum worker processes."),
--- 2625,2630 ----
*************** static struct config_real ConfigureNames
*** 3058,3063 ****
--- 2987,3064 ----
  
  static struct config_int64 ConfigureNamesInt64[] =
  {
+ 	{
+ 		{"vacuum_freeze_min_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
+ 			gettext_noop("Minimum age at which VACUUM should freeze a table row."),
+ 			NULL
+ 		},
+ 		&vacuum_freeze_min_age,
+ 		INT64CONST(50000000), INT64CONST(0), INT64CONST(0x7FFFFFFFFFFFFFFF),
+ 		NULL, NULL, NULL
+ 	},
+ 
+ 	{
+ 		{"vacuum_freeze_table_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
+ 			gettext_noop("Age at which VACUUM should scan whole table to freeze tuples."),
+ 			NULL
+ 		},
+ 		&vacuum_freeze_table_age,
+ 		INT64CONST(150000000), INT64CONST(0), INT64CONST(0x7FFFFFFFFFFFFFFF),
+ 		NULL, NULL, NULL
+ 	},
+ 
+ 	{
+ 		{"vacuum_multixact_freeze_min_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
+ 			gettext_noop("Minimum age at which VACUUM should freeze a MultiXactId in a table row."),
+ 			NULL
+ 		},
+ 		&vacuum_multixact_freeze_min_age,
+ 		INT64CONST(5000000), INT64CONST(0), INT64CONST(0x7FFFFFFFFFFFFFFF),
+ 		NULL, NULL, NULL
+ 	},
+ 
+ 	{
+ 		{"vacuum_multixact_freeze_table_age", PGC_USERSET, CLIENT_CONN_STATEMENT,
+ 			gettext_noop("Multixact age at which VACUUM should scan whole table to freeze tuples."),
+ 			NULL
+ 		},
+ 		&vacuum_multixact_freeze_table_age,
+ 		INT64CONST(150000000), INT64CONST(0), INT64CONST(0x7FFFFFFFFFFFFFFF),
+ 		NULL, NULL, NULL
+ 	},
+ 
+ 	{
+ 		{"vacuum_defer_cleanup_age", PGC_SIGHUP, REPLICATION_MASTER,
+ 			gettext_noop("Number of transactions by which VACUUM and HOT cleanup should be deferred, if any."),
+ 			NULL
+ 		},
+ 		&vacuum_defer_cleanup_age,
+ 		INT64CONST(0), INT64CONST(0), INT64CONST(1000000),
+ 		NULL, NULL, NULL
+ 	},
+ 
+ 	{
+ 		/* see varsup.c for why this is PGC_POSTMASTER not PGC_SIGHUP */
+ 		{"autovacuum_freeze_max_age", PGC_POSTMASTER, AUTOVACUUM,
+ 			gettext_noop("Age at which to autovacuum a table to prevent transaction ID wraparound."),
+ 			NULL
+ 		},
+ 		&autovacuum_freeze_max_age,
+ 		/* see pg_resetxlog if you change the upper-limit value */
+ 		INT64CONST(10000000000), INT64CONST(100000), INT64CONST(0x7FFFFFFFFFFFFFFF),
+ 		NULL, NULL, NULL
+ 	},
+ 	{
+ 		/* see multixact.c for why this is PGC_POSTMASTER not PGC_SIGHUP */
+ 		{"autovacuum_multixact_freeze_max_age", PGC_POSTMASTER, AUTOVACUUM,
+ 			gettext_noop("Multixact age at which to autovacuum a table to prevent multixact wraparound."),
+ 			NULL
+ 		},
+ 		&autovacuum_multixact_freeze_max_age,
+ 		INT64CONST(20000000000), INT64CONST(10000), INT64CONST(0x7FFFFFFFFFFFFFFF),
+ 		NULL, NULL, NULL
+ 	},
+ 
  	/* End-of-list marker */
  	{
  		{NULL, 0, 0, NULL, NULL}, NULL, 0.0, 0.0, 0.0, NULL, NULL, NULL
